/*  See:  http://en.wikipedia.org/wiki/Sieve_of_Eratosthenes
 *  Author:  Yotam Medini  yotam.medini@gmail.com -- Created: 2007/May/18
 */

#include <stdio.h>

extern void cancel(int* sieve, int sieve_len, int d);


void show_primes(int* sieve, int N)
{
    int  k = 0, d;
    while (k < N) {
        sieve[k] = 1;
        k++;
    }
    d = 2;  k = 1;
    while (d < N) {
        if (sieve[d] == 1) {
            printf("Prime[%5d] = %6d\n", k, d);   k++;
            cancel(sieve, N, d);
        }
        d++;
    }
} /* show_primes */

