#!/bin/bash -x
# Build prime program made of 3 C-source files.

# Make sure we delete old one
rm -f primes *.o

# Compile C files to *.o (objects)
gcc -Wall -c primes_main.c
gcc -Wall -c eratosthenes.c
gcc -Wall -c cancel.c

# Link the objects into an executable program
gcc -o primes primes_main.o eratosthenes.o cancel.o

# Show what was made
ls -l primes

